from PyKDE4.kdeui import *
from PyQt4.QtCore import *
from PyQt4.QtGui import *

class PidginItem(QTreeWidgetItem):
	buddy = 0
	group = 0
	alias = ""
	name = ""
	status = ""
	picture = ""
	status_text= ""
	colorGray1 = QBrush(QColor(128,128,128,128))
	colorGray2 = QBrush(QColor(128,128,128,32))
	colorRed = QBrush(QColor(128,0,0,128))
	colorBlue = QBrush(QColor(0,0,128,128))

	def __init__(self, parent, group, buddy, alias, status_text="", name="", status="", picture=None, recent=0):
		QTreeWidgetItem.__init__(self)
		self.parent = parent
		self.group = group
		self.buddy = buddy
		self.alias = alias 
		self.status = status
		try:
			self.status_text = str(status_text)
		except:
			self.status_text = ''
		self.picture = picture
		self.recent = recent
		self.name = name
	
		font = QFont()
		# not loaded
		if recent == -2:
			self.setBackground(0,self.colorGray1)
			self.setBackground(1,self.colorGray1)
			self.setTextColor(0,QColor(255,255,255))
			self.setTextColor(1,QColor(255,255,255))
		# a group
		elif buddy == 0:
			self.setBackground(0,self.colorGray1) # dark gray
			self.setBackground(1,self.colorGray1)
			font.setBold(True)
		# recently signed off
		elif recent == -1:
			self.setBackground(0,self.colorRed) # red
			self.setBackground(1,self.colorRed)
			self.setTextColor(0,QColor(255,255,255))
			self.setTextColor(1,QColor(255,255,255))
			
		# recently signed on
		elif recent == 1:
			self.setBackground(0,self.colorBlue) # blue
			self.setBackground(1,self.colorBlue)
		else:
			self.setBackground(0,self.colorGray2) # light gray
			self.setBackground(1,self.colorGray2)
		
		self.setFont(1,font)
		content = self.alias 
		if self.buddy != 0:
			# yes, this is a hack to replace HTML escaped entries!
			content += "\n" + self.status_text.replace("&#x3A;","\x3A").replace('&apos;',"'")
			
		else:
		  content += " (" + self.status_text + ")"
		self.setText(1, content)
		content = "";
		content += "<FONT SIZE=+2><B>"+self.alias+"</B></FONT>";
		if self.name:
			content += "<BR /><B>Name</B>: "+self.name;
		if self.status_text:
			content += "<BR /><B>Status text:</B> "+self.status_text
		if self.picture is not None:
			content += "<BR /><IMG SRC=\""+self.picture+"\">";
		self.setToolTip(0,content)
		# if it's not a group, set the default to draw an icon
		showdefault = self.buddy != 0
		if self.picture is not None:
			try:
				# draw buddy icon
				icon = QIcon(self.picture)
				self.setIcon(0, icon)
				# should check to make sure icon gets drawn properly?
				showdefault = 0
			except:
				print "error with:", self.picture
				showdefault = 1
		if showdefault:
			if status == "idle": defaultpic = "away"
			elif status == "online": defaultpic = "available"
			else: defaultpic = status
			icon = QIcon('/usr/share/pixmaps/pidgin/status/22/'+defaultpic+'.png')
			self.setIcon(0, icon)
		self.setTextAlignment(0, Qt.AlignHCenter | Qt.AlignVCenter)
		
		self.setTextAlignment(1, Qt.AlignTop | Qt.AlignLeft)
		
